
/* 
  SPS_CREATE - version 0.53, 2012.06.27
*/  

/* 
  Set of actions to install CoMinder SpaceStat into new database
  this is for new setup
  for upgrade - use upgrade script(s) specified in UPGRADE.txt
  
  Please, review ALL the scripts before execute!
  Manual installation executing DDL/scripts one by one may be better solution in this version.
  
  Installation by user with DBA privilegies (or check the scripts to see what exactly required)
  Execution by DBA or SPACESTAT user, having limited privilegies granted!
  
*/  

/* 
  First of all we create tablespace(s)
   
*/
@cre_tablespace.sql

/* 
  Then we need to create SPACESTAT user and schema and give select rights of some DBA_ views 
*/
@cre_user.sql

/* 
  Next: Create tables, indexes, constraints  
*/
@cre_tables.sql

/* 
  Next: Create Packages  
*/
@cre_packages.sql


/* Installation done
  next: check for invalid objects
*/
col OBJECT_TYPE format a16
col OBJECT_NAME format a16
col OBJECT_TYPE format a10  

select OBJECT_TYPE, OBJECT_NAME, STATUS 
  from dba_objects 
 where owner='SPACESTAT'
order by STATUS, OBJECT_TYPE, OBJECT_NAME;

/* 
  recompile if required   
  when OK - execute following SQL, just to track version number for later upgrade
*/  
update SPACESTAT.SPS_VERSION set status='VALID',upgrade_ts=sysdate;
commit;

