--
-- make changes report for period
-- Designed by: SIA CoMinder, Andrey Chervonets (ACE)
-- version 0.53 (2012.06.27)

SET SERVEROUTPUT ON VERIFY OFF

set lines 300
set pages 1000
@@sps_list_snaps.sql

ACCEPT old_id PROMPT "Please enter first snap_id value: "
ACCEPT new_id PROMPT "Please enter last snap_id value: "

VARIABLE  snap_1_info varchar2(255);
VARIABLE  snap_2_info varchar2(255);

VARIABLE  skip_schema varchar2(255);
VARIABLE  n_days_count number;
--:skip_schema = 'where OWNER not in ('SYS','SYSTEM','XDB','WMSYS') '
begin
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_2_info
    FROM SPACESTAT.SPS_SNAPS where snap_id=&new_id;
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_1_info
    FROM SPACESTAT.SPS_SNAPS where snap_id=&old_id;
  select ceil(max(start_time)-min(start_time)) into :n_days_count  
    from SPACESTAT.SPS_SNAPS where snap_id between &old_id and &new_id;   
  
end;
/
set lines 300
set pages 1000
set feed off

prompt SPACESTAT report for
-- db info
prompt Database Info:
prompt =======================
select name DB_Name,DBID,created,LOG_MODE from v$database;
-- instance info
column PROPERTY format a20
column VALUE format a40
select 'Hostname:' PROPERTY, HOST_NAME VALUE from v$instance
union all (select 'Instance:' PROPERTY, INSTANCE_NAME VALUE from v$instance) 
union all (select 'Started:' PROPERTY, to_char(STARTUP_TIME,'DD.MM.YYYY HH24:MI:SS') VALUE from v$instance)
union all (select 'Server IP:' PROPERTY, UTL_INADDR.get_host_address VALUE from dual)
union all (select 'OS:' PROPERTY,  dbms_utility.port_string VALUE from dual)
/
-- snapshots info
prompt === Snaps Info ===
exec DBMS_OUTPUT.PUT_LINE(' Begin Snap:'||:snap_1_info);
exec DBMS_OUTPUT.PUT_LINE('   End Snap:'||:snap_2_info);
exec DBMS_OUTPUT.PUT_LINE('    Elapsed:'||:n_days_count);

-- overal info 
exec DBMS_OUTPUT.PUT_LINE('=== Summary for DB === ');
set feed on
select SA.GB OLD_GB, SB.GB NEW_GB, (SB.GB-SA.GB) DELTA_GB, (SB.GB-SA.GB)/:n_days_count AVG_DAY_GB
  from (select SUM(A.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA A 
         where A.SNAP_ID=&old_id) SA
        , (select SUM(B.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA B 
         where B.SNAP_ID=&new_id) SB
order by  SB.GB desc
/

-- segment type
exec DBMS_OUTPUT.PUT_LINE('=== Summary by SEGMENT_TYPE === ');
column OWNER FORMAT a15
column SEGMENT_TYPE FORMAT a15
column SEGMENT_NAME FORMAT a30
column TABLESPACE_NAME FORMAT a30
column OLD_GB format 9999999.99
column NEW_GB format 9999999.99
column DELTA_GB format 9999999.99
column AVG_DAY_GB format 9999999.999

set feed on

select SA.SEGMENT_TYPE, SA.GB OLD_GB, SB.GB NEW_GB, (SB.GB-SA.GB) DELTA_GB
  from (select SEGMENT_TYPE, SUM(A.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA A 
         where A.SNAP_ID=&old_id
      group by SEGMENT_TYPE) SA
        , (select SEGMENT_TYPE, SUM(B.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA B 
         where B.SNAP_ID=&new_id
      group by SEGMENT_TYPE) SB
 where SA.SEGMENT_TYPE=SB.SEGMENT_TYPE
order by  SB.GB desc
/

set feed off
