--
-- report changes report for period
-- Designed by: SIA CoMinder, Andrey Chervonets (ACE)
-- version 0.53 (2012.06.27)

SET SERVEROUTPUT ON VERIFY OFF

set lines 300
set pages 1000
@@sps_list_snaps.sql

ACCEPT old_id_f PROMPT "Please enter first snap_id value (db files): "
ACCEPT new_id_f PROMPT "Please enter last snap_id value (db files): "
ACCEPT old_id_s PROMPT "Please enter first snap_id value (db segments): "
ACCEPT new_id_s PROMPT "Please enter last snap_id value (db segments): "

VARIABLE  snap_1f_info varchar2(255);
VARIABLE  snap_2f_info varchar2(255);
VARIABLE  snap_1s_info varchar2(255);
VARIABLE  snap_2s_info varchar2(255);

VARIABLE  skip_schema varchar2(255);
VARIABLE  n_days_count number;
--:skip_schema = 'where OWNER not in ('SYS','SYSTEM','XDB','WMSYS') '
begin
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_2f_info
    FROM SPACESTAT.SPS_SNAPS where snap_id=&new_id_f;
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_1f_info
    FROM SPACESTAT.SPS_SNAPS where snap_id=&old_id_f;
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_2s_info
    FROM SPACESTAT.SPS_SNAPS where snap_id=&new_id_s;
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_1s_info
    FROM SPACESTAT.SPS_SNAPS where snap_id=&old_id_s;

  select ceil(max(start_time)-min(start_time)) into :n_days_count  
    from SPACESTAT.SPS_SNAPS where snap_id between &old_id_f and &new_id_f;   
  
end;
/
set lines 300
set pages 1000
set feed off

prompt SPACESTAT report for
-- db info
prompt Database Info:
prompt =======================
select name DB_Name,DBID,created,LOG_MODE from v$database;
-- instance info
column PROPERTY format a20
column VALUE format a40
select 'Hostname:' PROPERTY, HOST_NAME VALUE from v$instance
union all (select 'Instance:' PROPERTY, INSTANCE_NAME VALUE from v$instance) 
union all (select 'Started:' PROPERTY, to_char(STARTUP_TIME,'DD.MM.YYYY HH24:MI:SS') VALUE from v$instance)
union all (select 'Server IP:' PROPERTY, UTL_INADDR.get_host_address VALUE from dual)
union all (select 'OS:' PROPERTY,  dbms_utility.port_string VALUE from dual)
/
-- snapshots info
prompt === Files ===
exec DBMS_OUTPUT.PUT_LINE(' Begin Snap:'||:snap_1f_info);
exec DBMS_OUTPUT.PUT_LINE('   End Snap:'||:snap_2f_info);
prompt === Segments ===
exec DBMS_OUTPUT.PUT_LINE(' Begin Snap:'||:snap_1s_info);
exec DBMS_OUTPUT.PUT_LINE('   End Snap:'||:snap_2s_info);
exec DBMS_OUTPUT.PUT_LINE('    Elapsed:'||:n_days_count);
-- database size
--- some common formatting
column OWNER FORMAT a15
column FILE_TYPE FORMAT a15
column SEGMENT_NAME FORMAT a40
column TABLESPACE_NAME FORMAT a30
column OLD_GB format 9999999.999
column NEW_GB format 9999999.999
column DELTA_GB format 9999999.999
column D_PCT format 999.99
column AVG_DAY_GB format 9999999.9999
---------
exec DBMS_OUTPUT.PUT_LINE('=== Files Size === ');
select SA.GB OLD_GB, SB.GB NEW_GB, (SB.GB-SA.GB) DELTA_GB, 100*(SB.GB-SA.GB)/SA.GB D_PCT, (SB.GB-SA.GB)/:n_days_count AVG_DAY_GB
  from (select SUM(A.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA A 
         where A.SNAP_ID=&old_id_f) SA
        , (select SUM(B.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA B 
         where B.SNAP_ID=&new_id_f) SB
order by  SB.GB desc
/
set feed off
exec DBMS_OUTPUT.PUT_LINE('=== By Files type === ');

set feed on
select SA.SEGMENT_TYPE FILE_TYPE, SA.GB OLD_GB, SB.GB NEW_GB, (SB.GB-SA.GB) DELTA_GB, 100*(SB.GB-SA.GB)/SA.GB D_PCT
  from (select SEGMENT_TYPE, SUM(A.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA A 
         where A.SNAP_ID=&old_id_f
      group by SEGMENT_TYPE) SA
        , (select SEGMENT_TYPE, SUM(B.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA B 
         where B.SNAP_ID=&new_id_f
      group by SEGMENT_TYPE) SB
 where SA.SEGMENT_TYPE=SB.SEGMENT_TYPE
order by  SB.GB desc
/

set feed off
--- segments
exec DBMS_OUTPUT.PUT_LINE('=== Segments Size === ');
select SA.GB OLD_GB, SB.GB NEW_GB, (SB.GB-SA.GB) DELTA_GB, 100*(SB.GB-SA.GB)/SA.GB D_PCT, (SB.GB-SA.GB)/:n_days_count AVG_DAY_GB
  from (select SUM(A.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA A 
         where A.SNAP_ID=&old_id_s) SA
        , (select SUM(B.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA B 
         where B.SNAP_ID=&new_id_s) SB
order by  SB.GB desc
/
set feed off
exec DBMS_OUTPUT.PUT_LINE('=== By Segment type === ');
column SEGMENT_TYPE FORMAT a15

set feed on
select SA.SEGMENT_TYPE SEGMENT_TYPE, SA.GB OLD_GB, SB.GB NEW_GB, (SB.GB-SA.GB) DELTA_GB, 100*(SB.GB-SA.GB)/SA.GB D_PCT
  from (select SEGMENT_TYPE, SUM(A.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA A 
         where A.SNAP_ID=&old_id_s
      group by SEGMENT_TYPE) SA
        , (select SEGMENT_TYPE, SUM(B.BYTES)/1024/1024/1024 GB 
          from SPACESTAT.SPS_SNAP_DATA B 
         where B.SNAP_ID=&new_id_s
      group by SEGMENT_TYPE) SB
 where SA.SEGMENT_TYPE=SB.SEGMENT_TYPE
order by  SB.GB desc
/

---- tablespaces --------
-- not implemented yet







