--
-- report changes for period
-- version 0.53 (2012.06.27)

SET SERVEROUTPUT ON VERIFY OFF

set lines 300
set pages 1000
@@sps_list_snaps.sql

ACCEPT old_id PROMPT "Please enter first snap_id value: "
ACCEPT new_id PROMPT "Please enter last snap_id value: "

VARIABLE  snap_1_info varchar2(255);
VARIABLE  snap_2_info varchar2(255);
VARIABLE  skip_schema varchar2(255);
--:skip_schema = 'where OWNER not in ('SYS','SYSTEM','XDB','WMSYS') ' 
begin
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_1_info
  FROM SPACESTAT.SPS_SNAPS where snap_id=&old_id;
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_2_info
  FROM SPACESTAT.SPS_SNAPS where snap_id=&new_id;
  

end;
/
set lines 300
set pages 1000
set feed off
exec DBMS_OUTPUT.PUT_LINE('=== New SEGMENTS existing in '||:snap_2_info||' only (or size=0 in '||:snap_1_info||') ===');
set feed on
column OWNER FORMAT a15
column SEGMENT_TYPE FORMAT a12
column SEGMENT_NAME FORMAT a40
column TABLESPACE_NAME FORMAT a20
column OLD_MB format 999999999.99
column NEW_MB format 999999999.99
column DELTA_MB format 999999999.99

select B.OWNER, B.SEGMENT_TYPE, B.SEGMENT_NAME, B.TABLESPACE_NAME, B.BYTES/1024/1024 NEW_MB
  from SPACESTAT.SPS_SNAP_DATA B
 where B.SNAP_ID=&new_id
 -- and B.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
  and not exists (select BYTES
                    from SPACESTAT.SPS_SNAP_DATA A
                   where A.SNAP_ID=&old_id
                     and A.OWNER=B.OWNER
                     and A.SEGMENT_TYPE=B.SEGMENT_TYPE
                     and A.SEGMENT_NAME=B.SEGMENT_NAME
   --                  and A.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
                     )
order by B.BYTES DESC, B.OWNER, B.SEGMENT_TYPE, B.SEGMENT_NAME
/


-- prompt ======= REMOVED SEGMENTS (new size=0) =========
set feed off
exec DBMS_OUTPUT.PUT_LINE('=== Old SEGMENTS exist in '||:snap_1_info||' only (or size=0 in '||:snap_2_info||') ===');
set feed on

select A.OWNER, A.SEGMENT_TYPE, A.SEGMENT_NAME, A.TABLESPACE_NAME, A.BYTES/1024/1024 OLD_MB
  from SPACESTAT.SPS_SNAP_DATA A
 where A.SNAP_ID=&old_id
  -- and A.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
  and not exists (select BYTES
                    from SPACESTAT.SPS_SNAP_DATA B
                   where B.SNAP_ID=&new_id
                     and A.OWNER=B.OWNER
                     and A.SEGMENT_TYPE=B.SEGMENT_TYPE
                     and A.SEGMENT_NAME=B.SEGMENT_NAME
     --                and B.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
                     )
order by  A.BYTES DESC, A.OWNER, A.SEGMENT_TYPE, A.SEGMENT_NAME                     
/

prompt ======= CHANGED SEGMENTS  =========
select A.OWNER, A.SEGMENT_TYPE, A.SEGMENT_NAME, A.TABLESPACE_NAME, A.BYTES/1024/1024 OLD_MB, B.BYTES/1024/1024 NEW_MB, (B.BYTES-A.BYTES)/1024/1024 DELTA_MB
  from SPACESTAT.SPS_SNAP_DATA A, SPACESTAT.SPS_SNAP_DATA B
 where A.OWNER=B.OWNER
   and A.SEGMENT_TYPE=B.SEGMENT_TYPE
   and A.SEGMENT_NAME=B.SEGMENT_NAME
   -- and A.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
   -- and B.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
   and A.SNAP_ID=&old_id and B.SNAP_ID=&new_id
   and B.BYTES<>A.BYTES
   and A.SEGMENT_TYPE<>'TYPE2 UNDO'
order by  B.BYTES-A.BYTES DESC
/

prompt ======= NOT CHANGED SEGMENTS NOT LISTED =========

/*
select A.OWNER, A.SEGMENT_TYPE, A.SEGMENT_NAME, A.TABLESPACE_NAME, A.BYTES OLD_BYTES, B.BYTES NEW_BYTES, (B.BYTES-A.BYTES)/1024/1024 DELTA_MB
  from SPACESTAT.SPS_SNAP_DATA A, SPACESTAT.SPS_SNAP_DATA B
 where A.OWNER=B.OWNER
   and A.SEGMENT_TYPE=B.SEGMENT_TYPE
   and A.SEGMENT_NAME=B.SEGMENT_NAME
   and A.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
   and B.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
   and A.SNAP_ID=&old_id and B.SNAP_ID=&new_id
   and B.BYTES=A.BYTES
   and A.SEGMENT_TYPE<>'TYPE2 UNDO'
order by  B.BYTES-A.BYTES DESC
/

*/