#!/bin/bash
#
# Version: 0.53 (2012.06.27)
# Info: CoMinder SpaceStat - collection of scripts to gather 
#       and report information about space used by objects in DB
#       See more details in README.txt
#
# Developed by: CoMinder, http://www.cominder.eu, Andrey Chervonets (ACE) 
# Changes:
# 2011.12.28: 0.50: ACE: 1st version using repository DB for all remote DB
# 2012.02.16: 0.51: ACE: for each DB personally, no need central repository and DB-links
#                      : repository DB may be supported in later versions 
# 2012.06.26: 0.53: ACE: 

if [ -z "${1}" ] ; then
   echo "Usage: ${0} ORACLE_SID"
   exit 1
else
   DB_SID=${1}
   BASE_DIR=`dirname $0`
fi

# set environment variables - now hardcoded call of script with all required
# but You can implement it in any fashion You like
# 
. /u01/app/oracle/product/set9.2.0.8

# why not set ORACLE_SID directly? in some placese setNNNN script can unset it :)
#
ORACLE_SID=${DB_SID}
export ORACLE_SID

# specify what snapshot types are required 
# DBS - for DB segments (DBA_SEGMENTS)
# DBF - for DB files info (DBA_DATA_FILES, DBA_TEMP_FILES, redo-logs, control-files)
# or ALL - for ALL supported snapshot types in DB (DBS+DBF)
sqlplus "/ as sysdba" <<EOF
@${BASE_DIR}/sps_snap.sql ALL 
-- @${BASE_DIR}/sps_snap.sql DBS
-- @${BASE_DIR}/sps_snap.sql DBF
quit
EOF



